// A program for testing the quality
// of normal distributed pseudorandom numbers

// (C) 1997-1998 Frank Paehlke <frank@paehlke.de>
// $Id: randtest.cc,v 1.1 2003/10/14 08:59:11 frank Exp $

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// $Log: randtest.cc,v $
// Revision 1.1  2003/10/14 08:59:11  frank
// moved from . to src/
//
// Revision 1.4  2003/10/14 08:41:58  frank
// ANSI C++ / gcc 3.x compatibility changes
//
// Revision 1.3  2002/08/02 14:45:06  paehlke
// added GPL comment
//
// Revision 1.2  1998/05/28 12:56:38  paehlke
// Final version for masters thesis
//
// Revision 1.1  1997/06/20 18:45:39  frank
// Initial revision
//

#include <math.h>
#include <iostream>
#include "mlcg.h"
// #include "normal.h"
#include "normal2.h"

using namespace std;

// The result must be a chi-square distribution:
// x^(n/2-1)*exp(-x/2)/(2^(n/2)*gamma(n/2))

const int n=100;	// # of dimensions
const int k=1000000;	// # of iterations

const double n3 = 3.0*n;
const double n100 = 100.0/n;
//const double n3 = 10.0;
//const double n100 = 30.0;

int h[300];

int main ()
{
  int i,j;
  MLCG rg (12345,23456);
  Normal<MLCG> ng (&rg);
  for(i=0;i<k;i++) {
    double d2 = 0.0;
    for (j=0; j<n; j++)
      {
 	double d = ng();
 	d2 += d*d;
      }
    if (d2 >= n3) continue;
    int d2i=(int)floor(d2*n100);
    h[d2i]++;
  }
  //  cout << '[';
  //  for (i=0;i<299;i++) cout << h[i] << ',';
  // cout << h[i] << "]\n";
  cout << "# n = " << n << "\n# " << k << " iterations\n";
  for (i=0; i<300; i++) {
    cout << (i+.5)/n100 << '\t' << h[i] << endl;
  }
}
